<template>
  <v-container>
    <confirmation-modal :is-open="openModal" :modal-text="modalText" @confirm="confirmRegister" @cancel="cancelRegister" />
    <v-row justify="space-between">
      <v-col cols="12" md="5">
        <p class="page-title">
          Nuevo Paciente
        </p>
      </v-col>
    </v-row>
    <v-row justify="space-between">
      <v-col cols="12" md="5">
        <p class="page-sub-title">
          Información del paciente
        </p>
      </v-col>
    </v-row>
    <v-row justify="start" align="center">
      <v-col cols="3">
        <register-image
          v-model="newPatient.multipartFile"
          class="ml-4"
          :upload-available="uploadAvailable"
          :default-image="previewImage"
          text-image="Ingrese la imagen"
          @uploaded="handleUploaded"
        />
      </v-col>
      <v-col cols="3">
        <register-button :button-name="textEdit" :outlined="false" @clicked="handleCancelImage" />
      </v-col>
    </v-row>
    <v-form ref="newEntityForm" v-model="valid" class="mt-8" lazy-validation>
      <register-field
        v-model="newPatient.dni"
        field-name="DNI:"
        :rules="DNIRules"
        :counter="8"
      />
      <register-field
        v-model="newPatient.name"
        field-name="Nombre:"
        :rules="nameRules"
      />
      <register-field
        v-model="newPatient.fatherLastname"
        field-name="Apellido Paterno:"
        :rules="fatherLastnameRules"
      />
      <register-field
        v-model="newPatient.motherLastname"
        field-name="Apellido Materno:"
        :rules="motherLastnameRules"
      />
      <register-field
        v-model="newPatient.email"
        field-name="Correo:"
        :rules="emailRules"
      />
      <register-field
        v-model="newPatient.phone"
        field-name="Teléfono:"
        :rules="phoneRules"
        :counter="9"
      />
      <birthday-picker
        v-model="newPatient.birthday"
        field-name="Fecha de nacimiento:"
      />
    </v-form>
    <v-row justify="end">
      <v-col md="2">
        <register-button class="buttonRegisterLeft" button-name="Guardar" :outlined="false" @clicked="handleRegisterPatient" />
      </v-col>
      <v-col md="1">
        <register-button class="buttonRegisterRight" button-name="Cancelar" :outlined="true" @clicked="handleCancelRegister" />
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import { mapActions } from 'vuex';
import RegisterField from '~/components/register/registerField';
import RegisterImage from '~/components/register/registerImage';
import RegisterButton from '~/components/register/registerButton';
import { DNIRules, nameRules, emailRules, phoneRules, fatherLastnameRules, motherLastnameRules } from '~/helpers/validation';
import ConfirmationModal from '~/components/register/confirmationModal';
import BirthdayPicker from '~/components/register/birthdayPicker';
import { imageDefault } from '~/helpers/constants';

export default {
  name: 'NuevoPaciente',
  components: { BirthdayPicker, ConfirmationModal, RegisterButton, RegisterImage, RegisterField },
  data() {
    return {
      valid: true,
      DNIRules,
      nameRules,
      emailRules,
      phoneRules,
      fatherLastnameRules,
      motherLastnameRules,
      uploadAvailable: true,
      textEdit: 'Editar Imagen',
      previewImage: imageDefault,
      modalText: '¿Estás seguro que deseas registrar este paciente?',
      newPatient: {
        name: '',
        dni: '',
        fatherLastname: '',
        motherLastname: '',
        email: '',
        phone: '',
        birthday: '',
        multipartFile: null,
      },
      openModal: false,
    };
  },
  methods: {
    async confirmRegister() {
      await this.registerNewPatient();
      await this.getPatients();
      await this.$router.push('/entidad/pacientes');
    },
    cancelRegister() {
      this.openModal = false;
    },
    handleCancelImage() {
      if (this.uploadAvailable && this.textEdit === 'Editar Imagen') {
        this.textEdit = 'Cancelar';
        this.uploadAvailable = false;
        this.colorButton = 'secondary';
      } else {
        if (this.previewImage === '') {
          this.previewImage = imageDefault;
        } else {
          this.previewImage = '';
        }
        this.textEdit = 'Editar Imagen';
        this.uploadAvailable = true;
        // EMITIR LA CONSULTA DE NUEVO
        this.colorButton = 'green';
      }
    },
    ...mapActions({
      getPatients: 'clientcompany/patient/getPatients',
      registerPatient: 'clientcompany/patient/registerPatient',
    }),
    async registerNewPatient() {
      const formData = new FormData();
      if (this.newPatient.multipartFile === null) {
        fetch(imageDefault)
          .then(function (response) {
            return response.blob();
          })
          .then(function (blob) {
            formData.append('multipartFile', blob);
          });
      } else {
        formData.append('multipartFile', this.newPatient.multipartFile);
      }
      formData.append('dni', this.newPatient.dni);
      formData.append('name', this.newPatient.name);
      formData.append('fatherLastname', this.newPatient.fatherLastname);
      formData.append('motherLastname', this.newPatient.motherLastname);
      formData.append('email', this.newPatient.email);
      formData.append('phoneNumber', this.newPatient.phone);
      formData.append('birthday', this.newPatient.birthday);
      await this.registerPatient({ patient: formData });
    },
    handleUploaded() {
      this.uploadAvailable = true;
    },
    handleRegisterPatient() {
      if (this.$refs.newEntityForm.validate()) {
        this.openModal = true;
      }
    },
    handleCancelRegister() {
      this.$router.push('/entidad/pacientes');
    },
  },
};
</script>

<style scoped>
.page-title {
  font-family: 'Montserrat', sans-serif;
  font-size: 1.5rem;
  margin-top: 1rem;
  margin-left: 1rem;
}
.page-sub-title {
  font-family: 'Montserrat', sans-serif;
  font-size: 1rem;
  margin-top: 1rem;
  margin-left: 1rem;
}
.buttonRegisterLeft {
  margin-top: 3rem;
  margin-left: 4rem;
}
.buttonRegisterRight {
  margin-top: 3rem;
}
</style>
